locals @@
p586
                model flat
CODE            segment para public 'CODE' use32

                public start
start           proc near
                push    0
                call    GetModuleHandleA
                mov     Our_Handle, eax
                push    1
                pop     eax
                retn    0Ch
start           endp

public   P2K_Init
public   P2K_GetStatus
public   P2K_Restart
public   P2K_Suspend
public   P2K_SuspendEx
public   P2K_PowerOff
public   P2K_SendCMD
public   Mode_SwitchToP2k
public   Mode_SwitchToAT
public   Mode_SwitchToTF
public   SetCOMPort
public   Seem_Read
public   Seem_Write
public   File_Close
public   File_Create
public   File_Read
public   File_Write
public   File_Delete
public   File_SetPointer
public   File_VolInfo
public   File_Count
public   File_CountEx
public   File_List
public   File_ListEx
public   File_CreateDir
public   File_DeleteDir
public   File_GetFreeSpace
public   USB_ReadData
public   USB_WriteData


File_DeleteDir  proc near

arg_0           = dword ptr  8

                push    ebp
                mov     ebp, esp

                push    esi
                push    edx
                push    ecx

                cmp     TCI_IF, -1
                jz      @@fail

                mov     Cmd_Recv_Size, 0
                mov     byte ptr Cmd_Recv_Buf, 0
                mov     dword ptr Cmd_Send_Buf, 0F000000h ; Cmd - del dir
                mov     dword ptr [Cmd_Send_Buf+4], 0
                mov     esi, [ebp+arg_0]
                push    esi
                call    lstrlenA
                xor     edx, edx
                cmp     eax, 0
                jz      @@fail

@@name_cpy_loop:
                mov     cl, [esi+edx]
                mov     byte ptr [Cmd_Send_Buf+8+edx], cl
                inc     edx
                cmp     edx, eax
                jl      short @@name_cpy_loop

                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                add     eax, 8
                push    eax
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand
                cmp     eax, 0
                jnz     @@fail
                cmp     Cmd_Recv_Size, 1
                jz      @@fail
                cmp     Cmd_Recv_Buf, 1
                jz      @@fail
                xor     eax, eax
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     ecx
                pop     edx
                pop     esi

                leave
                retn    4
File_DeleteDir  endp


File_CreateDir   proc near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch

                push    ebp
                mov     ebp, esp

                push    esi
                push    ebx
                push    ecx

                cmp     TCI_IF, -1
                jz      @@fail

                mov     edi, offset Cmd_Send_Buf
                mov     Cmd_Recv_Size, 0

                mov     eax, [ebp+arg_4]
                xchg    ah, al
                rol     eax, 10h
                xchg    ah, al
                mov     dword ptr [edi+04h], eax
                mov     dword ptr [edi+00h], 0E000000h ; Cmd 0E - Create Dir

                push    [ebp+arg_0]
                call    lstrlenA
                cmp     eax, 0
                jz      @@fail
                mov     ecx, 200h ; Maximum fname size
                cmp     eax, ecx
                ja      @@fail
                push    edi

                add     edi, 8
                mov     esi, [ebp+arg_0] ; fname
                xor     edx, edx
@@name_cpy_loop:
                mov     cl, [esi+edx]
                mov     [edi+edx], cl
                inc     edx
                cmp     edx, eax
                jl      short @@name_cpy_loop
                pop     edi

                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                add     eax, 8
                push    eax ; in data size - name len+8
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand
                
                xor     eax,eax  ; sorry for this. sometimes all ok, but function return error
                jmp     @@exit   ;

;                cmp     eax, 0
;                jnz     @@fail
;                cmp     word ptr Cmd_Recv_Size, 1
;                jz      @@fail
;                cmp     byte ptr Cmd_Recv_Buf, 1
;                jz      @@fail
                                    
;                xor     eax, eax
;                jmp     @@exit


@@fail:
                mov     eax, -1
@@exit:
                pop     ecx
                pop     ebx
                pop     esi
                leave
                retn    8
File_CreateDir  endp


File_Create     proc near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch

                push    ebp
                mov     ebp, esp

                push    esi
                push    ebx
                push    ecx

                cmp     TCI_IF, -1
                jz      @@fail

                cmp     File_opened, 0
                jnz     @@fail
                mov     edi, offset Cmd_Send_Buf
                mov     Cmd_Recv_Size, 0

                mov     eax, [ebp+arg_4]
                xchg    ah, al
                rol     eax, 10h
                xchg    ah, al
                mov     dword ptr [edi+04h], eax
                mov     dword ptr [edi+00h], 0 ; Cmd 0 - Open

                push    [ebp+arg_0]
                call    lstrlenA
                cmp     eax, 0
                jz      @@fail
                mov     ecx, 200h ; Maximum fname size
                cmp     eax, ecx
                ja      @@fail
                push    edi

                add     edi, 8
                mov     esi, [ebp+arg_0] ; fname
                xor     edx, edx
@@name_cpy_loop:
                mov     cl, [esi+edx]
                mov     [edi+edx], cl
                inc     edx
                cmp     edx, eax
                jl      short @@name_cpy_loop
                pop     edi

                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                add     eax, 8
                push    eax ; in data size - name len+8
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand
                cmp     eax, 0
                jnz     @@fail
                inc     File_opened
                cmp     Cmd_Recv_Size, 1
                jnz     short @@exit
                cmp     byte ptr Cmd_Recv_Buf, 0
                jnz     short @@exit
                xor     eax, eax
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     ecx
                pop     ebx
                pop     esi
                leave
                retn    8
File_Create     endp

File_Close      proc near
                cmp     TCI_IF, -1
                jz      @@fail
                cmp     File_opened, 0
                jz      @@fail
                mov     Cmd_Recv_Size, 0
                mov     byte ptr Cmd_Recv_Buf, 0
                mov     dword ptr Cmd_Send_Buf, 04000000h ; Cmd
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    4
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 1
                jz      @@fail
                cmp     byte ptr Cmd_Recv_Buf, 1
                jz      @@fail
                dec     File_opened
                xor     eax, eax
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                retn
File_Close      endp

File_Read       proc near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch

                push    ebp
                mov     ebp, esp

                push    ecx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                mov     edi, [ebp+arg_4] ; size
                cmp     edi, 0
                jz      @@fail

@@loop:
                cmp     edi, 400h
                jbe     @@b_400h
                mov     eax, 400h
                jmp     @@store_size
@@b_400h:
                mov     eax, edi
@@store_size:
                xchg    ah, al
                rol     eax, 10h
                xchg    ah,al

                mov     dword ptr Cmd_Send_Buf, 01000000h
                mov     dword ptr Cmd_Send_Buf+04h, eax

                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    8
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand

                cmp     eax, 0
                jnz     @@fail

                mov     ecx, Cmd_Recv_Size
                test    cx, cx
                jbe     short @@fail

                xor     esi, esi
                mov     eax, [ebp+arg_0]
                add     eax, [ebp+arg_4]
                sub     eax, edi
@@buf_loop:
                mov     cl, byte ptr [Cmd_Recv_Buf+esi]
                mov     [esi+eax], cl

                mov     ecx, Cmd_Recv_Size
                inc     esi
                and     ecx, 0FFFFh
                cmp     esi, ecx
                jl      short @@buf_loop

                cmp     edi, 400h
                jbe     @@exit_ok
                sub     edi, 400h
                jmp     @@loop
@@exit_ok:
                mov     esi, 0
                jmp     @@exit
@@fail:
                mov     esi, -1
@@exit:
                mov     eax, esi
                pop     edi
                pop     esi
                pop     ebx
                pop     ecx
                leave
                retn    8
File_Read       endp

File_Write      proc near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch

                push    ebp
                mov     ebp, esp
                push    edx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                xor     esi, esi
                mov     dword ptr Cmd_Send_Buf+0, 02000000h ; Cmd
                mov     Cmd_Recv_Size, 0
                mov     byte ptr Cmd_Recv_Buf, 0

                mov     ebx, [ebp+arg_4] ; Size

@@loop1:
                xor     eax, eax
                mov     edi, [ebp+arg_0]

                cmp     ebx, 0
                jz      @@block_wr_ok
                cmp     ebx, 400h ; mstapi uses this buf size...
                jb      short @@last_block

                mov     edx, 400h
                jmp     @@loop_datacopy
@@last_block:
                mov     edx, ebx
@@loop_datacopy:
                push    edx
                xchg    dh, dl
                rol     edx, 10h
                xchg    dh, dl
                mov     dword ptr Cmd_Send_Buf+4, edx
                pop     edx

                mov     cl, [edi+esi]
                mov     byte ptr [Cmd_Send_Buf+8+eax], cl
                inc     eax
                inc     esi
                cmp     eax, edx
                jl      short @@loop_datacopy
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                add     edx, 8
                push    edx
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 1
                jnz     short @@block_wr_ok
                cmp     byte ptr Cmd_Recv_Buf, 6
                jnz     short @@fail
@@block_wr_ok:
                mov     eax, 0
                sub     edx, 8
                sub     ebx, edx
                jz      @@exit
                jmp     short @@loop1

@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                leave
                retn    8
File_Write      endp

File_SetPointer  proc near

arg_0           = dword ptr  8
arg_4           = byte ptr  0Ch

                push    ebp
                mov     ebp, esp

                cmp     TCI_IF, -1
                jz      @@fail

                mov     dword ptr Cmd_Send_Buf, 03000000h ; Cmd

                mov     eax, [ebp+arg_0]
                xchg    ah, al
                rol     eax, 10h
                xchg    ah, al
                mov     dword ptr Cmd_Send_Buf+4, eax
                mov     al, [ebp+arg_4]
                mov     byte ptr Cmd_Send_Buf+8, al
                mov     Cmd_Recv_Size, 0
                mov     byte ptr Cmd_Recv_Buf, 0
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    9
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 1
                jz      @@fail
                cmp     byte ptr Cmd_Recv_Buf, 1
                jz      @@fail
                xor     eax, eax
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                leave
                retn    8
File_SetPointer endp

File_Delete     proc near

arg_0           = dword ptr  8

                push    ebp
                mov     ebp, esp

                push    esi
                push    edx
                push    ecx

                cmp     TCI_IF, -1
                jz      @@fail

                mov     Cmd_Recv_Size, 0
                mov     byte ptr Cmd_Recv_Buf, 0
                mov     dword ptr Cmd_Send_Buf, 05000000h ; Cmd
                mov     esi, [ebp+arg_0]
                push    esi
                call    lstrlenA
                xor     edx, edx
                cmp     eax, 0
                jz      @@fail

@@name_cpy_loop:
                mov     cl, [esi+edx]
                mov     byte ptr [Cmd_Send_Buf+4+edx], cl
                inc     edx
                cmp     edx, eax
                jl      short @@name_cpy_loop
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                add     eax, 4
                push    eax
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand
                cmp     eax, 0
                jnz     @@fail
                cmp     Cmd_Recv_Size, 1
                jz      @@fail
                cmp     Cmd_Recv_Buf, 1
                jz      @@fail
                xor     eax, eax
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     ecx
                pop     edx
                pop     esi

                leave
                retn    4
File_Delete     endp


File_GetFreeSpace proc near
arg_0           = dword ptr 8

                push    ebp
                mov     ebp, esp

                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail


                mov     byte ptr Cmd_Recv_Buf, 0
                mov     dword ptr Cmd_Send_Buf, 0B000000h ; Cmd
                mov     edi, offset Cmd_Send_Buf
                mov     esi, [ebp+arg_0]
                mov     ecx, 4
                mov     word ptr [edi+ecx], 0700h
                add     ecx,2

                mov     byte ptr [edi+ecx], 0
                inc     ecx
                mov     al,[esi]
                mov     [edi+ecx],al
                inc     esi
                inc     ecx

                mov     byte ptr [edi+ecx], 0
                inc     ecx
                mov     al,[esi]
                mov     [edi+ecx],al
                inc     esi
                inc     ecx

                mov     byte ptr [edi+ecx], 0
                inc     ecx
                mov     al,[esi]
                mov     [edi+ecx],al
                inc     esi
                inc     ecx
                
                mov     word ptr [edi+ecx], 0
                add     ecx,2
                

                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    ecx
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 1
                jz      @@fail
                cmp     byte ptr [esi], 6
                jz      @@fail
              
                mov     edx, dword ptr Cmd_Recv_Buf
                xchg    dh, dl
                rol     edx, 10h
                xchg    dh, dl
                mov     eax,edx
                cmp     edx, 0                      ; in edx size of free space
              
                jnz     @@exit

@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx
                leave
                retn    4
File_GetFreeSpace endp


File_VolInfo    proc near

arg_0           = dword ptr  8

                push    ebp
                mov     ebp, esp

                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                mov     esi, [ebp+arg_0]
                mov     ecx, 80h
                xor     eax, eax
                mov     edi, esi
                repe stosd
                mov     word ptr Cmd_Recv_Buf, 0
                mov     dword ptr Cmd_Send_Buf, 0A000000h ; Cmd

                push    offset Cmd_Recv_Size
                push    esi
                push    4
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 1
                jz      @@fail
                cmp     byte ptr [esi], 6
                jz      @@fail

                mov     edi, offset Cmd_Send_Buf
                mov     ecx, 80h
                xor     eax, eax
                rep stosd

                mov     byte ptr Cmd_Recv_Buf, 0
                mov     dword ptr Cmd_Send_Buf, 0B000000h ; Cmd
                mov     edi, offset Cmd_Send_Buf
                add     edi, 4
                mov     ax, 0
                stosw
                mov     esi, [ebp+arg_0]
@@loop:
                lodsw
                cmp     ax, 0
                jz      @@go_fsac
                stosw
                inc     ecx
                cmp     ecx, 80h
                jl      short @@loop

@@go_fsac:
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    200h
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 1
                jz      @@fail
                cmp     byte ptr [esi], 6
                jz      @@fail
              
                mov     edx, dword ptr Cmd_Recv_Buf
                xchg    dh, dl
                rol     edx, 10h
                xchg    dh, dl
                cmp     edx, 0 
              
                jnz     @@ok
                jmp     @@fail
@@ok:
                mov     esi, [ebp+arg_0]
                mov     edi, [ebp+arg_0]
@@cvt_loop:
                lodsw
                xchg    ah, al
                stosb
                cmp     al, 0
                jnz     @@cvt_loop

                mov     eax, edx
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx
                leave
                retn    4
File_VolInfo    endp

File_Count      proc near
                push    ebp
                mov     ebp, esp
                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi
; Request files count
                cmp     TCI_IF, -1
                jz      @@fail

                mov     word ptr Cmd_Recv_Buf, -1
                mov     dword ptr Cmd_Send_Buf, 07000000h ; Cmd
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    4
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 2
                jb      @@fail
                cmp     word ptr Cmd_Recv_Buf, 0
                jbe     @@fail                           ; nothing to search
                cmp     word ptr Cmd_Recv_Buf, -1
                jz      @@fail

                xor     eax, eax
                mov     ax, word ptr Cmd_Recv_Buf
                xchg    ah, al
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx
                leave
                retn
File_Count      endp


File_CountEx      proc near

arg_0           = dword ptr  8

                push    ebp
                mov     ebp, esp
                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi
                
                mov     edi, [ebp+arg_0]          ; edi - search mask:  /b/*.*
                mov     esi, offset Cmd_Send_Buf
                mov     ecx, 4                    ; ecx - offset in Cmd_Send_Buf
                xor     eax, eax                  ; eax - offset in mask


@@again1:       cmp byte ptr [edi+eax], '*'
                jz      @@end_of_path
                mov     byte ptr [esi+ecx], 0
                inc     ecx
                mov     bl, [edi+eax]
                mov     [esi+ecx], bl
                inc     eax
                inc     ecx
                jmp     @@again1

@@end_of_path:                
               
                mov     word ptr [esi+ecx], 0FEFFh
                add     ecx,2

@@again:        cmp     byte ptr [edi+eax], 0
                jz      @@end_of_mask
                mov     byte ptr [esi+ecx], 0
                inc     ecx
                mov     bl, [edi+eax]
                mov     [esi+ecx], bl
                inc     eax
                inc     ecx
                jmp     @@again
@@end_of_mask:
                mov     word ptr [esi+ecx], 0
                add     ecx,2
                
                
; Request files count
                cmp     TCI_IF, -1
                jz      @@fail

                mov     word ptr Cmd_Recv_Buf, -1
                mov     dword ptr Cmd_Send_Buf, 07000000h ; Cmd
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    ecx
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand
                cmp     eax, 0
                jnz     @@fail
                cmp     word ptr Cmd_Recv_Size, 2
                jb      @@fail
                cmp     word ptr Cmd_Recv_Buf, 0
                jbe     @@fail                           ; nothing to search
                cmp     word ptr Cmd_Recv_Buf, -1
                jz      @@fail

                xor     eax, eax
                mov     ax, word ptr Cmd_Recv_Buf
                xchg    ah, al
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx
                leave
                retn  4
File_CountEx      endp

File_List       proc near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch

                push    ebp
                mov     ebp, esp
                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                mov     esi, [ebp+arg_4]
                mov     edi, [ebp+arg_0]

@@loop:
; request block of records
                mov     word ptr Cmd_Recv_Buf, -1
                mov     dword ptr Cmd_Send_Buf, 08000000h ; Cmd
                mov     byte ptr Cmd_Send_Buf+4, 03h
                push    offset Cmd_Recv_Size
                push    offset Search_Buf
                push    5
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand

                cmp     eax, 0
                jnz     @@fail

                mov     eax, Cmd_Recv_Size
                sub     eax, 4
                cdq
                mov     ecx, 2Ch
                mov     FileList_RecSize, ecx
                idiv    ecx
                cmp     edx, 0
                jz      @@rec_ok

                mov     eax, Cmd_Recv_Size
                sub     eax, 4
                cdq
                mov     ecx, 10Ch
                mov     FileList_RecSize, ecx
                idiv    ecx
                cmp     edx, 0
                jz      @@rec_ok
                mov     edx, 0
                mov     FileList_RecSize, edx
                jmp     @@fail

@@rec_ok:
                movzx   eax, word ptr [Search_Buf] ; records readed
                xchg    ah, al
                sub     esi, eax

                push    esi
                mov     ecx, eax
                mov     esi, offset Search_Buf
                add     esi, 4

@@copy_loop:
                mov     ebx, FileList_RecSize
                mov     eax, [esi+ebx-4]
                xchg    ah, al
                rol     eax,10h
                xchg    ah,al
                stosd
                mov     ax, [esi+ebx-6h]
                xchg    ah, al
                stosw
                mov     ax, [esi+ebx-8]
                xchg    ah, al
                stosw

                push    esi
                push    edi
                push    ecx
                mov     ecx, FileList_RecSize
                sub     ecx, 8
                rep     movsb
                mov     al, 0
                stosb
                pop     ecx
                pop     edi
                pop     esi
                add     esi, FileList_RecSize
                add     edi, 1F8h
                loop    @@copy_loop

                pop     esi

                cmp     esi, 0
                ja      @@loop

                mov     eax, FileList_RecSize
                sub     eax, 8
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx
                leave
                retn    8
File_List       endp


File_ListEx       proc near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h

                push    ebp
                mov     ebp, esp
                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                mov     FileRecCount,0
                mov     esi, [ebp+arg_4]
                mov     edi, [ebp+arg_0]

@@loop:
; request block of records
                mov     word ptr Cmd_Recv_Buf, -1
                mov     dword ptr Cmd_Send_Buf, 08000000h ; Cmd
                mov     byte ptr Cmd_Send_Buf+4, 03h
                push    offset Cmd_Recv_Size
                push    offset Search_Buf
                push    5
                push    offset Cmd_Send_Buf
                push    004Ah                   ; FSAC
                push    TCI_IF
                call    P2K_SendCommand

                cmp     eax, 0
                jnz     @@fail

                mov     eax, Cmd_Recv_Size
                sub     eax, 4
                cdq
                mov     ecx, 2Ch
                mov     FileList_RecSize, ecx
                idiv    ecx
                cmp     edx, 0
                jz      @@rec_ok

                mov     eax, Cmd_Recv_Size
                sub     eax, 4
                cdq
                mov     ecx, 10Ch
                mov     FileList_RecSize, ecx
                idiv    ecx
                cmp     edx, 0
                jz      @@rec_ok
                mov     edx, 0
                mov     FileList_RecSize, edx
                jmp     @@fail

@@rec_ok:
                movzx   eax, word ptr [Search_Buf] ; records readed
                xchg    ah, al
                sub     esi, eax

                push    esi
                mov     ecx, eax
                mov     esi, offset Search_Buf
                add     esi, 4

@@copy_loop:
                mov     ebx, FileList_RecSize
                mov     eax, [esi+ebx-4]
                xchg    ah, al
                rol     eax,10h
                xchg    ah,al
                stosd
                mov     ax, [esi+ebx-6h]
                xchg    ah, al
                stosw
                mov     ax, [esi+ebx-8]
                xchg    ah, al
                stosw

                push    esi
                push    edi
                push    ecx
                mov     ecx, FileList_RecSize
                sub     ecx, 8
                rep     movsb
                mov     al, 0
                stosb
              
                pushad
                push    [ebp+arg_4]
                push    FileRecCount
                push    [ebp+arg_0]
                mov     esi,[ebp+arg_8]
                call    esi
                popad
                inc     FileRecCount
              
                pop     ecx
                pop     edi
                pop     esi
                add     esi, FileList_RecSize
                add     edi, 1F8h
                loop    @@copy_loop

                pop     esi

                cmp     esi, 0
                ja      @@loop

                mov     eax, FileList_RecSize
                sub     eax, 8
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx
                leave
                retn    12
File_ListEx       endp


Seem_Read       proc near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h
arg_C           = dword ptr  14h
arg_10          = dword ptr  18h

                push    ebp
                mov     ebp, esp
                push    ecx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                mov     eax, [ebp+arg_0] ; seem
                xchg    al, ah
                mov     seem_num, ax

                mov     eax, [ebp+arg_4] ; record
                xchg    al, ah
                mov     seem_rec, ax

                mov     eax, [ebp+arg_8] ; ofs
                xchg    al, ah
                mov     seem_ofs, ax

                mov     eax, [ebp+arg_C] ; bytes
                xchg    al, ah
                mov     seem_bytes, ax


                mov     seem_read_bytes, 0

                push    offset seem_read_bytes
                push    offset seem_buf
                push    8                     ; DataBuf size
                push    offset seem_num
                push    020h           ; COMMAND - RDELEM
                push    TCI_IF
                call    P2K_SendCommand
                test    eax, eax
                jnz     @@fail
                mov     eax, 0
                mov     ecx, seem_read_bytes
                cmp     seem_read_bytes, 0
                jbe     short @@ok
                mov     edi, [ebp+arg_10]
                mov     bl, seem_buf
                test    bl, bl
                jnz     @@fail
@@ok:
                mov     edi, [ebp+arg_10]
                mov     esi, offset seem_buf+1
                mov     ecx, seem_read_bytes
                dec     ecx
                rep     movsb
                mov     eax, seem_read_bytes
                dec     eax
                jmp     @@exit
@@fail:
                mov     eax, -1
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     ecx
                leave
                retn    14h
Seem_Read       endp

Seem_Write      proc near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h
arg_C           = dword ptr  14h
arg_10          = dword ptr  18h

                push    ebp
                mov     ebp, esp

                push    ecx
                push    ebx
                push    esi
                push    edi

                cmp     TCI_IF, -1
                jz      @@fail

                mov     eax, [ebp+arg_0] ; seem
                xchg    al, ah
                mov     seem_num, ax

                mov     eax, [ebp+arg_4] ; record
                xchg    al, ah
                mov     seem_rec, ax

                mov     eax, [ebp+arg_8] ; ofs
                xchg    al, ah
                mov     seem_ofs, ax

                mov     eax, [ebp+arg_C] ; bytes
                cmp     eax,0
                jbe     @@fail
                cmp     eax, 2710h
                jna     @@zize_ok
                mov     eax, 2710h
@@zize_ok:
                mov     [ebp+arg_C], eax
                xchg    al, ah
                mov     seem_bytes, ax

                mov     esi, [ebp+arg_10]
                mov     edi, offset seem_data
                mov     ecx, [ebp+arg_C]
                rep     movsb

                mov     seem_read_bytes, 0

                push    offset seem_read_bytes
                push    offset stelem_result

                mov     eax, [ebp+arg_C] ; bytes
                add     eax, 8
                push    eax                   ; DataBuf size
                push    offset seem_num

                push    02Fh        ; COMMAND STELEM
                push    TCI_IF
                call    P2K_SendCommand
                test    eax, eax
                jnz     @@fail
                mov     eax, 0
                mov     bl, byte ptr stelem_result
                test    bl, bl
                jz      short @@ok
@@fail:
                mov     eax, -1
@@ok:
                pop     edi
                pop     esi
                pop     ebx
                pop     ecx
                leave
                retn    14h
Seem_Write      endp

P2K_SuspendEx   proc    near
arg_0         = dword ptr  8
                push    ebp
                mov     ebp,esp
                cmp     TCI_IF, -1
                jz      @@fail
                mov     eax,[ebp+arg_0]
                mov     byte ptr Cmd_Send_Buf, al
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    1
                push    offset Cmd_Send_Buf
                push    0036h                   ; SUSPEND
                push    TCI_IF
                call    P2K_SendCommand
                movzx   eax,byte ptr Cmd_Recv_Buf
@@fail:
                leave
                retn    04h
P2K_SuspendEx   endp

P2K_PowerOff    proc near
                cmp     TCI_IF, -1
                jz      @@fail
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    0
                push    offset Cmd_Send_Buf
                push    001Eh                   ; PWROFF
                push    TCI_IF
                call    P2K_SendCommand
@@fail:
                retn
P2K_PowerOff    endp  

P2K_Suspend     proc near
                cmp     TCI_IF, -1
                jz      @@fail
                mov     byte ptr Cmd_Send_Buf, 0
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    1
                push    offset Cmd_Send_Buf
                push    0036h                   ; SUSPEND
                push    TCI_IF
                call    P2K_SendCommand
@@fail:
                retn
P2K_Suspend     endp

P2K_Restart     proc    near
                cmp     TCI_IF, -1
                jz      @@fail
                push    offset Cmd_Recv_Size
                push    offset Cmd_Recv_Buf
                push    0
                push    offset Cmd_Send_Buf
                push    0022h                  ; RESTART
                push    TCI_IF
                call    P2K_SendCommand
@@fail:
                retn
P2K_Restart     endp

SetCOMPort      proc near
arg_0           = dword ptr  8

                push    ebp
                mov     ebp, esp
                
                push    esi
                push    edi
                push    ecx
                push    eax
                
                mov     esi, [ebp+arg_0]

                cmp     esi,0
                jnz     @@manual
                mov     ManualCOM, 00h
                jmp     @@exit
                
                

@@manual:
                mov     ManualCOM, 01h
                mov     edi, offset keyval_buf
                xor     ecx, ecx
@@cpy:                
                mov     al, [esi+ecx]
                mov     [edi+ecx],al
                inc     ecx
                cmp     al,0                
                jnz     @@cpy


@@exit:
                pop     eax
                pop     ecx
                pop     edi
                pop     esi
                
                leave
                retn    4    
SetCOMPort      endp


Mode_SwitchToP2k proc near

arg_0           = dword ptr  8

                cmp     Thread_Handle,0
                jnz      @@inited
                push    ebp
                mov     ebp, esp                
                push    dword ptr [ebp+arg_0]
                call    P2K_Init
                leave
                retn    04h

@@inited:

                cmp     Thread_Suspended,00h
                jz      @@done
                
                
                push    Thread_Handle
                call    ResumeThread
                mov     Thread_Suspended,0h
                
@@done:                

                retn   04h 
Mode_SwitchToP2k endp


Mode_SwitchToTF proc near

;arg_0           = dword ptr  8


                call    Mode_SwitchToAT
                mov     HackModeTF,1
                push    0
                call    Mode_SwitchToP2k

@@done:                

                leave
                retn    
Mode_SwitchToTF endp


Mode_SwitchToAT proc near

                 push    ebp
                 mov     ebp, esp
      
                 push    ecx
                 push    ebx
                 push    esi
                 push    edi
 
                 cmp     TCI_IF, -1
                 jz      @@done

                 cmp     Thread_Suspended,00h
                 jnz     @@done
                 cmp     Thread_Handle,00h
                 jz      @@done
                 push    Thread_Handle
                 call    SuspendThread
                 mov     Thread_Suspended,1h
         
                 mov     packet_size,9
                 push    offset packet_size
                 push    offset SwitchToAT_Buff
;                 push    TCI_IF
                 
                 call    USB_WriteData

                 
                
@@done:                

                 mov     DevFound,0
                 cmp     Mon_CB, 0
                 jz      @@skip_mon_cb
                 push    0
                 call    Mon_CB
@@skip_mon_cb:

                 pop     edi
                 pop     esi
                 pop     ebx
                 pop     ecx
                 leave
                 retn    
Mode_SwitchToAT  endp



P2K_Init        proc near
arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h
arg_C           = dword ptr  14h

                enter   0, 0
                mov     eax, [ebp+arg_0]
                mov     Mon_CB, eax
                
                cmp     Thread_Handle,0FFFFFFFFh
                jz      @@already_inited
                
         ;       mov     ManualCOM, 01h
         ;       mov     esi, offset str_usb_modem
         ;       mov     edi, offset keyval_buf
         ;       xor     ecx, ecx
;@@cpy:                
         ;       mov     al, [esi+ecx]
         ;       mov     [edi+ecx],al
         ;       inc     ecx
         ;       cmp     al,0                
         ;       jnz     @@cpy
                
                push    offset Thread_Id
                push    0
                push    0
                push    offset DevMonitor_Proc
                push    0
                push    0
                call    CreateThread
                mov     Thread_Handle, eax
                jmp     @@done

@@already_inited:
                cmp     Thread_Suspended, 00h
                jz      @@done
                push    Thread_Handle
                call    ResumeThread
                
@@done:                
                mov  eax,0
                leave
                retn 4
P2K_Init        endp

P2K_GetStatus   proc near
                mov  eax, DevFound
                retn
P2K_GetStatus   endp

DevMonitor_Proc proc near
@@init_fail:
                mov     TCI_IF, -1
                push    3E8h
                call    Sleep
                call    SwitchFromDataCard
;                push    3E8h
;                call    Sleep
                cmp     ManualCOM,1
                jz      @@man_com
                call    COM_Find
                jmp     @@auto_com
@@man_com:               
                ;in keyval_buf must be our com port 
                xor     eax,eax
@@auto_com:
                cmp     eax, 0
                jnz     @@no_comm
                call    Switch_mode
                push    1388h
                call    Sleep
                cmp     HackModeTF,1
                jnz     @@skip_hack
                mov     DevFound,0
                push    Thread_Handle
                call    SuspendThread
                mov     Thread_Suspended,1h
                
                jmp     @@hack
@@no_comm:

@@skip_hack:
                call    FindUSBClass
@@hack:                
                mov     HackModeTF,0
                cmp     DevFound, 1
                jnz     @@init_fail



                mov     eax, Dev_Name_Ptr
                add     eax, 4
                push    eax
                push    offset str_devclass_key
                push    offset str_buf
                call    wsprintfA
                add     esp, 0Ch
                mov     byte ptr [str_buf+56h], '#'
                mov     byte ptr [str_buf+57h], '#'
                mov     byte ptr [str_buf+59h], '#'

                ; str_buf
;                push    offset MI
;                push    offset str_buf
;                call    StrStrIA
;                cmp     eax,0
;                jz      @@not_found_mi
;                add     eax,4
;                mov     bl,[eax]
;                sub     bl,48
;                shl     bl,4
;                inc     eax
;                mov     bh,[eax]
;                sub     bh,48
;                or      bl,bh
;                xor     bh,bh
;                mov     IFindex,bx
;                jmp     @@found_mi
;@@not_found_mi:
;                mov     IFindex, 0FFFFh
;@@found_mi:                

                
                cmp     Mon_CB, 0
                jz      @@skip_cb_on
                push    1
                call    Mon_CB
@@skip_cb_on:
                
                
                push    offset Key_Class_handle  ; handle
                push    20019h         ; access mask
                push    0              ; res
                push    offset str_buf ; subkey
                push    80000002h      ; key
                call    RegOpenKeyExA

                push    0 ; async flag
                push    0; Key_Event
                push    5 ;notify filter - name+last_set
                push    1 ; flag subkey notify
                push    Key_Class_handle
                call    RegNotifyChangeKeyValue

                push    Key_Class_handle
                call    RegCloseKey
                cmp     Mon_CB, 0
                jz      @@skip_cb_off
                push    0
                call    Mon_CB
@@skip_cb_off:
                push    Dev_Name_Ptr
                call    GlobalFree

                mov     DevFound, 0

                push    1388h
                call    Sleep
                jmp     @@init_fail
DevMonitor_Proc endp

P2K_SendCommand proc near
arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h
arg_C           = dword ptr  14h
arg_10          = dword ptr  18h
arg_14          = dword ptr  1Ch

                push    ebp
                mov     ebp, esp

                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi
                inc     Packet_ID
                cmp     Packet_ID, 1000h
                jb      @@skip_id_fix
                mov     Packet_ID, 0
@@skip_id_fix:

                mov     edi, offset packet_buf
                mov     ecx, 400h
                xor     eax, eax
                rep     stosd

                mov     ax,  IFindex
                mov     edi, offset packet_buf
                mov     byte ptr [edi+00h], 41h
                mov     byte ptr [edi+01h], 02h
                mov     word ptr [edi+02h], 0000h
                mov     word ptr [edi+04h], ax ; Interface
                mov     eax, [ebp+arg_C]
                add     eax, 8
                mov     word ptr [edi+06h], ax    ; size ws command & size
                mov     dx, Packet_ID
                and     dx, 0FFFh
                xchg    dh, dl
                mov     word ptr [edi+08h], dx ; random - Packet ID
                mov     edx, [ebp+arg_4]
                and     dx,0FFFh
                xchg    dh,dl
                mov     word ptr [edi+0Ah], dx ; command
                mov     eax, [ebp+arg_C]
                xchg    ah, al
                mov     word ptr [edi+0Ch], ax    ; size
                mov     word ptr [edi+0Eh], 0000h
                mov     eax, [ebp+arg_C]
                add     eax, 12h
                mov     packet_size, eax
                mov     esi, [ebp+arg_8]
                add     edi, 10h
                mov     ecx, [ebp+arg_C]
                rep     movsb

                push    offset packet_size
                push    offset packet_buf
;                push    [ebp+arg_0]
                call    USB_WriteData
                cmp     eax, 0
                jz      @@Write_ok

;                push    offset msg_cmd_write_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit

@@Write_ok:
                call    GetTickCount
                mov     ReadStatus_Ticks, eax
@@status_loop:
                mov     edi, offset status_read_buf
                mov     ecx, 3
                xor     eax, eax
                rep     stosd

                mov     ax, IFindex
                mov     edi, offset status_read_buf
                mov     byte ptr [edi+00h], 0C1h
                mov     byte ptr [edi+01h], 0
                mov     word ptr [edi+02h], 0
                mov     word ptr [edi+04h], ax
                mov     word ptr [edi+06h], 8

                mov     status_read_size, 0Ch

                push    offset status_read_size
                push    offset status_read_buf
                ;push    [ebp+arg_0]
                call    USB_ReadData

                cmp     eax, 0
                jnz     @@next_try
                mov     al, status_read_buf+1
                cmp     al, 3
                jae     @@next_try
                cmp     al, 0
                jnz     @@done
@@next_try:
                push    1
                call    Sleep

                call    GetTickCount
                sub     eax, ReadStatus_Ticks
                cmp     eax, 9C40h ; timeout
                jb      @@status_loop

;                push    offset msg_cmd_timeout
;                call    logstat
                mov     eax,-1
                jmp     @@exit

@@done:
                push    1
                call    Sleep

                mov     edi, offset data_read_buf
                mov     ecx, 400h
                xor     eax, eax
                rep     stosd

                mov     cx, IFindex
                mov     edi, offset data_read_buf
                mov     byte ptr [edi+00h], 0C1h
                mov     byte ptr [edi+01h], 1
                movzx   ax, byte ptr status_read_buf+1
                mov     word ptr [edi+02h], ax ; packets #
                mov     word ptr [edi+04h], cx ; IF

                shl     ax, 1
                mov     cx, word ptr status_read_buf+2
                xchg    ch, cl
                add     ax, cx
;                add     ax, word ptr status_read_buf+4
;                add     ax, word ptr status_read_buf+6
                add     ax, 4
                mov     word ptr [edi+06h], ax ; Size

                mov     data_read_size, 0FA4h
                push    offset data_read_size
                push    offset data_read_buf
;                push    [ebp+arg_0]
                call    USB_ReadData
                cmp     eax, 0
                jz      @@Read_ok

;                push    offset msg_cmd_read_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@Read_ok:
                mov     esi, offset data_read_buf
                cmp     byte ptr [esi+00h], 1
                jnz     @@fail
                mov     cx, [esi+04h]
                xchg    ch,cl
                mov     dl, [esi+06h]
                and     dl, 80h
                cmp     dl, 80h
                jnz     @@fail
                mov     dx, [esi+06h]
                xchg    dh, dl
                and     dx, 0FFFh ; Packet ID
                cmp     Packet_ID, dx
                jnz     @@fail
                mov     dl, [esi+08h]
                shr     dl, 4

                cmp     dl, 6        ; Answ 6 - result ok, no data returned
                mov     eax, 0
                jz      @@exit

                cmp     dl, 8        ; Answ 8 - result ok
                jz      @@op_ok
                and     edx, 0Fh
;                mov     eax, [IO_Err+edx*4]
;                push    eax
;                call    logstat
                mov     USB_Last_Err, eax
                mov     eax, -1
                jmp     @@exit
@@op_ok:
                mov     dx, [esi+0Ah]
                xchg    dh, dl
                sub     cx, 8
                cmp     cx, dx
                jnz     @@fail ; bad packet - size mismatch
                jmp     @@ok

@@fail:
;                push    offset msg_cmd_answer_fail
;                call    logstat
                mov     eax, 1
                jmp     @@exit

@@ok:
                add     esi, 0Eh
                mov     edi, [ebp+arg_10]
                mov     eax, [ebp+arg_14]
                and     ecx, 0FFFFh
                mov     [eax], ecx
                rep     movsb
                mov     eax, 0
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx
                leave
                retn    18h
P2K_SendCommand endp



P2K_SendCMD proc near

arg_4           = dword ptr  8
arg_8           = dword ptr  0Ch
arg_C           = dword ptr  10h
arg_10          = dword ptr  14h
arg_14          = dword ptr  18h

;arg_0           = dword ptr  8
;arg_4           = dword ptr  0Ch
;arg_8           = dword ptr  10h
;arg_C           = dword ptr  14h
;arg_10          = dword ptr  18h
;arg_14          = dword ptr  1Ch

                push    ebp
                mov     ebp, esp

                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi
                inc     Packet_ID
                cmp     Packet_ID, 1000h
                jb      @@skip_id_fix
                mov     Packet_ID, 0
@@skip_id_fix:

                mov     edi, offset packet_buf
                mov     ecx, 400h
                xor     eax, eax
                rep     stosd

                mov     ax, IFindex
                mov     edi, offset packet_buf
                mov     byte ptr [edi+00h], 41h
                mov     byte ptr [edi+01h], 02h
                mov     word ptr [edi+02h], 0000h
                mov     word ptr [edi+04h], ax ; Interface
                mov     eax, [ebp+arg_C]
                add     eax, 8
                mov     word ptr [edi+06h], ax    ; size ws command & size
                mov     dx, Packet_ID
                and     dx, 0FFFh
                xchg    dh, dl
                mov     word ptr [edi+08h], dx ; random - Packet ID
                mov     edx, [ebp+arg_4]
                and     dx,0FFFh
                xchg    dh,dl
                mov     word ptr [edi+0Ah], dx ; command
                mov     eax, [ebp+arg_C]
                xchg    ah, al
                mov     word ptr [edi+0Ch], ax    ; size
                mov     word ptr [edi+0Eh], 0000h
                mov     eax, [ebp+arg_C]
                add     eax, 12h
                mov     packet_size, eax
                mov     esi, [ebp+arg_8]
                add     edi, 10h
                mov     ecx, [ebp+arg_C]
                rep     movsb

                push    offset packet_size
                push    offset packet_buf
;                push    TCI_IF
                call    USB_WriteData
                cmp     eax, 0
                jz      @@Write_ok

;                push    offset msg_cmd_write_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit

@@Write_ok:
                call    GetTickCount
                mov     ReadStatus_Ticks, eax
@@status_loop:
                mov     edi, offset status_read_buf
                mov     ecx, 3
                xor     eax, eax
                rep     stosd

                mov     ax, IFindex
                mov     edi, offset status_read_buf
                mov     byte ptr [edi+00h], 0C1h
                mov     byte ptr [edi+01h], 0
                mov     word ptr [edi+02h], 0
                mov     word ptr [edi+04h], ax
                mov     word ptr [edi+06h], 8

                mov     status_read_size, 0Ch

                push    offset status_read_size
                push    offset status_read_buf
;                push    TCI_IF
                call    USB_ReadData

                cmp     eax, 0
                jnz     @@next_try
                mov     al, status_read_buf+1
                cmp     al, 3
                jae     @@next_try
                cmp     al, 0
                jnz     @@done
@@next_try:
                push    1
                call    Sleep

                call    GetTickCount
                sub     eax, ReadStatus_Ticks
                cmp     eax, 9C40h ; timeout
                jb      @@status_loop

;                push    offset msg_cmd_timeout
;                call    logstat
                mov     eax,-1
                jmp     @@exit

@@done:
                push    1
                call    Sleep

                mov     edi, offset data_read_buf
                mov     ecx, 400h
                xor     eax, eax
                rep     stosd

                mov     cx, IFindex
                mov     edi, offset data_read_buf
                mov     byte ptr [edi+00h], 0C1h
                mov     byte ptr [edi+01h], 1
                movzx   ax, byte ptr status_read_buf+1
                mov     word ptr [edi+02h], ax ; packets #
                mov     word ptr [edi+04h], cx ; IF

                shl     ax, 1
                mov     cx, word ptr status_read_buf+2
                xchg    ch, cl
                add     ax, cx
;                add     ax, word ptr status_read_buf+4
;                add     ax, word ptr status_read_buf+6
                add     ax, 4
                mov     word ptr [edi+06h], ax ; Size

                mov     data_read_size, 0FA4h
                push    offset data_read_size
                push    offset data_read_buf
;                push    TCI_IF
                call    USB_ReadData
                cmp     eax, 0
                jz      @@Read_ok

;                push    offset msg_cmd_read_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@Read_ok:
                mov     esi, offset data_read_buf
                cmp     byte ptr [esi+00h], 1
                jnz     @@fail
                mov     cx, [esi+04h]
                xchg    ch,cl
                mov     dl, [esi+06h]
                and     dl, 80h
                cmp     dl, 80h
                jnz     @@fail
                mov     dx, [esi+06h]
                xchg    dh, dl
                and     dx, 0FFFh ; Packet ID
                cmp     Packet_ID, dx
                jnz     @@fail
                mov     dl, [esi+08h]
                shr     dl, 4

                cmp     dl, 6        ; Answ 6 - result ok, no data returned
                mov     eax, 0
                jz      @@exit

                cmp     dl, 8        ; Answ 8 - result ok
                jz      @@op_ok
                and     edx, 0Fh
;                mov     eax, [IO_Err+edx*4]
;                push    eax
;                call    logstat
                mov     USB_Last_Err, eax
                mov     eax, -1
                jmp     @@exit
@@op_ok:
                mov     dx, [esi+0Ah]
                xchg    dh, dl
                sub     cx, 8
                cmp     cx, dx
                jnz     @@fail ; bad packet - size mismatch
                jmp     @@ok

@@fail:
;                push    offset msg_cmd_answer_fail
;                call    logstat
                mov     eax, 1
                jmp     @@exit

@@ok:
                add     esi, 0Eh
                mov     edi, [ebp+arg_10]
                mov     eax, [ebp+arg_14]
                and     ecx, 0FFFFh
                mov     [eax], ecx
                rep     movsb
                mov     eax, 0
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx
                leave
                retn    14h

P2K_SendCMD endp



                
USB_WriteData   proc    near

arg_4           = dword ptr  8
arg_8           = dword ptr  0Ch
;arg_8           = dword ptr  10h

                push    ebp
                mov     ebp, esp

                push    0
                push    0
                push    1
                push    0
                call    CreateEventA
                cmp     eax, 0
                jnz     @@event_ok

;                push    offset msg_usb_event_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@event_ok:
                mov     DevIO_Event, eax

                push    DevIO_Event
                call    ResetEvent
                cmp     eax, 0
                jnz     @@reset_ok

                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_reset_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@reset_ok:

                push    offset DevIO_Overlapped
                push    0
                push    5
                push    offset DevIO_Result
                mov     eax,[ebp+arg_8] ; InBuf_Size
                mov     eax, [eax]
                push    eax
                push    [ebp+arg_4]     ; InBuf
                push    80002014h
                push    TCI_IF
                call    DeviceIoControl

                push    2710h
                push    DevIO_Event
                call    WaitForSingleObject
                cmp     eax, 0
                jz      @@wait_ok

                push    TCI_IF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_wait_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@wait_ok:
                push    0
                push    [ebp+arg_8] ; InBuf_Size - recvd
                push    offset DevIO_Overlapped
                push    TCI_IF
                call    GetOverlappedResult
                cmp     eax, 0
                jnz     @@devio_ok

                push    TCI_IF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_result_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit

@@devio_ok:
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_write_ok
;                call    logstat
                mov     eax, 0
@@exit:
                leave
                retn    08h
USB_WriteData   endp

USB_WriteDataEx proc    near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h
arg_C           = dword ptr  14h
arg_10          = dword ptr  18h

                push    ebp
                mov     ebp, esp
                push    ecx
                push    edx
                push    ebx
                push    esi
                push    edi

                push    0
                push    0
                push    1
                push    0
                call    CreateEventA
                cmp     eax, 0
                jnz     @@event_ok

;                push    offset msg_usb_event_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@event_ok:
                mov     DevIO_Event, eax

                push    DevIO_Event
                call    ResetEvent
                cmp     eax, 0
                jnz     @@reset_ok

                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_reset_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@reset_ok:
                mov     edi, offset packet_buf
                mov     esi, [ebp+arg_4]
                mov     al, byte ptr [ebp+arg_C]
                stosb
                mov     eax,[ebp+arg_8] ; InBuf_Size
                mov     eax, [eax]
                stosd
                mov     ecx, eax
                rep     movsb
                push    offset DevIO_Overlapped
                push    0
                push    0
                push    0
                add     eax, 6
                push    eax
                push    offset packet_buf ; [ebp+arg_4]     ; InBuf
                push    80002018h
                push    [ebp+arg_0]
                call    DeviceIoControl

                push    [ebp+arg_10]
                push    DevIO_Event
                call    WaitForSingleObject
                cmp     eax, 0
                jz      @@wait_ok

                push    [ebp+arg_0]
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_wait_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@wait_ok:
                push    0
                push    [ebp+arg_8] ; InBuf_Size - recvd
                push    offset DevIO_Overlapped
                push    [ebp+arg_0]
                call    GetOverlappedResult
                cmp     eax, 0
                jnz     @@devio_ok

                push    [ebp+arg_0]
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_result_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit

@@devio_ok:
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_write_ok
;                call    logstat
                mov     eax, 0
@@exit:
                pop     edi
                pop     esi
                pop     ebx
                pop     edx
                pop     ecx
                leave
                retn    14h
USB_WriteDataEx endp

                USB_ReadData    proc    near

arg_4           = dword ptr  8
arg_8           = dword ptr  0Ch
;arg_8           = dword ptr  10h

                push    ebp
                mov     ebp, esp

                push    0
                push    0
                push    1
                push    0
                call    CreateEventA
                cmp     eax, 0
                jnz     @@event_ok

;                push    offset msg_usb_event_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@event_ok:
                mov     DevIO_Event, eax

                push    DevIO_Event
                call    ResetEvent
                cmp     eax, 0
                jnz     @@reset_ok

                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_reset_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@reset_ok:

                push    offset DevIO_Overlapped
                push    0
                push    1005h
                push    offset DevIO_Result
                mov     eax,[ebp+arg_8] ; InBuf_Size
                push    9
                push    [ebp+arg_4]     ; InBuf
                push    80002014h
                push    TCI_IF
                call    DeviceIoControl

                push    9C40h
                push    DevIO_Event
                call    WaitForSingleObject
                cmp     eax, 0
                jz      @@wait_ok

                push    TCI_IF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_wait_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@wait_ok:

                push    0
                push    [ebp+arg_8] ; InBuf_Size - recvd
                push    offset DevIO_Overlapped
                push    TCI_IF
                call    GetOverlappedResult
                cmp     eax, 0
                jnz     @@devio_ok

                push    TCI_IF
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_result_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@devio_ok:
                mov     esi, [ebp+arg_8]
                mov     ecx, [esi]
                cmp     ecx, 4
                jnb     @@size_ok
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_size_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@size_ok:
                sub     ecx, 4
                mov     [esi], ecx
                mov     esi, offset DevIO_Result
                add     esi, 4
                mov     edi, [ebp+arg_4]
                rep     movsb
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_read_ok
;                call    logstat
                mov     eax, 0
@@exit:
                leave
                retn    08h
USB_ReadData    endp

USB_ReadDataEx  proc    near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h
arg_C           = dword ptr  14h
arg_10          = dword ptr  18h

                push    ebp
                mov     ebp, esp

                push    esi

                push    0
                push    0
                push    1
                push    0
                call    CreateEventA
                cmp     eax, 0
                jnz     @@event_ok

;                push    offset msg_usb_event_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@event_ok:
                mov     DevIO_Event, eax

                push    DevIO_Event
                call    ResetEvent
                cmp     eax, 0
                jnz     @@reset_ok

                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_reset_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@reset_ok:

                mov     edi, offset packet_buf
                mov     al, byte ptr [ebp+arg_C]
                stosb
                mov     eax, [ebp+arg_8]
                mov     eax, [eax]
                stosd

                push    offset DevIO_Overlapped
                push    0
                push    1005h
                push    offset DevIO_Result
                push    5
                push    offset packet_buf
                push    8000201Ch
                push    [ebp+arg_0]
                call    DeviceIoControl

                push    [ebp+arg_10]
                push    DevIO_Event
                call    WaitForSingleObject
                cmp     eax, 0
                jz      @@wait_ok

                push    [ebp+arg_0]
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_wait_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@wait_ok:

                push    0
                push    [ebp+arg_8] ; InBuf_Size - recvd
                push    offset DevIO_Overlapped
                push    [ebp+arg_0]
                call    GetOverlappedResult
                cmp     eax, 0
                jnz     @@devio_ok

                push    [ebp+arg_0]
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_result_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@devio_ok:
                mov     esi, [ebp+arg_8]
                mov     ecx, [esi]
                cmp     ecx, 4
                jnb     @@size_ok
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_size_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@size_ok:
                sub     ecx, 4
                mov     [esi], ecx
                mov     esi, offset DevIO_Result
                add     esi, 4
                mov     edi, [ebp+arg_4]
                rep     movsb
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_read_ok
;                call    logstat
                mov     eax, 0
@@exit:
                pop     esi

                leave
                retn    14h
USB_ReadDataEx  endp

USB_GetIFInfo   proc    near

arg_0           = dword ptr  8
arg_4           = dword ptr  0Ch
arg_8           = dword ptr  10h

                push    ebp
                mov     ebp, esp

                push    ecx
                push    esi
                push    edi

                push    0
                push    0
                push    1
                push    0
                call    CreateEventA
                cmp     eax, 0
                jnz     @@event_ok

;                push    offset msg_usb_event_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@event_ok:
                mov     DevIO_Event, eax

                push    DevIO_Event
                call    ResetEvent
                cmp     eax, 0
                jnz     @@reset_ok

                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_reset_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@reset_ok:
                mov     eax, [ebp+arg_4]
                mov     IF_Info_cmd, eax

                push    offset DevIO_Overlapped
                push    offset IF_Info_recvd
                push    105h
                push    [ebp+arg_8]
                push    2
                push    offset IF_Info_cmd ; InBuf
                push    80002010h
                push    [ebp+arg_0]
                call    DeviceIoControl

                push    1388h
                push    DevIO_Event
                call    WaitForSingleObject
                cmp     eax, 0
                jz      @@wait_ok

                push    [ebp+arg_0]
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_wait_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@wait_ok:

                push    0
                push    offset IF_Info_recvd ; InBuf_Size - recvd
                push    offset DevIO_Overlapped
                push    [ebp+arg_0]
                call    GetOverlappedResult
                cmp     eax, 0
                jnz     @@devio_ok

                push    [ebp+arg_0]
                call    CancelIo
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_result_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@devio_ok:
                cmp     IF_Info_recvd, 4
                jnb     @@size_ok
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_size_fail
;                call    logstat
                mov     eax, -1
                jmp     @@exit
@@size_ok:
                push    DevIO_Event
                call    CloseHandle
;                push    offset msg_usb_read_ok
;                call    logstat
                mov     ecx, [ebp+arg_8]
                mov     ecx, [ecx]
                mov     esi, [ebp+arg_8]
                add     esi, 4
                mov     edi, [ebp+arg_8]
@@str_loop:
                lodsw
                stosb
                loop    @@str_loop

                mov     eax, 0
@@exit:
                pop     edi
                pop     esi
                pop     ecx
                leave
                retn    0Ch
USB_GetIFInfo   endp


;------------- Phone initialize procs ----------------
COM_Find        proc near
                push    ebp
                mov     ebp, esp
                push    edi
                push    ecx
                push    esi
                push    ebx

                mov     eax, dwRasSize
                mov     dwRasCb, eax
                
                push    offset dwRasDevices
                push    offset dwRasCb
                push    0
                call    RasEnumDevicesA
                
                push    dwRasCb
                push    0
                call    GlobalAlloc
                mov     lpRasDevInfo,eax
                push    eax

                mov     eax,lpRasDevInfo
                mov     ebx,dwRasSize
                mov     [eax],ebx
                
                push    offset dwRasDevices
                push    offset dwRasCb
                push    lpRasDevInfo
                call    RasEnumDevicesA
                
                xor     ecx,ecx

@@loop:                
                push    ecx
                cmp     ecx,dwRasDevices
                jae     @@fail 
                
                
                mov     esi, lpRasDevInfo
                add     esi, 4
                push    esi
                push    offset sRasModem
                call    lstrcmpA
                cmp     eax,0
                jnz     @@next_step
                
                mov     esi, lpRasDevInfo
                add     esi, 21
                push    offset sRasMoto
                push    esi
                call    StrStrIA
                cmp     eax,0
                jz      @@next_step

                mov     esi, lpRasDevInfo
                add     esi, 21
                push    esi 
                push    offset sRasMask
                push    offset keyval_buf
                call    wsprintfA
                add     esp, 0Ch
                jmp     @@good
                

@@next_step:
                pop     ecx
                mov     eax,dwRasSize
                add     lpRasDevInfo,eax
                inc     ecx
                jmp     @@loop
                
@@good:
                pop     ecx
                xor     eax, eax
                jmp     @@exit
@@fail:
                pop     ecx
                mov     eax, -1
@@exit:
                call    GlobalFree    
                push    ebx
                push    esi
                pop     ecx
                pop     edi
                leave
                retn
COM_Find        endp

Switch_mode     proc near
                push    ebp
                mov     ebp, esp

                push    -1
                push    0
                push    1 ; Create new
                push    0
                push    0
                push    0C0000000h ; generic RW
                push    offset keyval_buf
                call    CreateFileA
                mov     ComHandle, eax
                cmp     eax,0
                jnz     @@create_ok
                mov     eax, -1
                jmp     @@exit
@@create_ok:
                push    0
                push    offset at_readed
                push    0Bh
                cmp     HackModeTF,1
                jz      @@hack
                push    offset at_mode
                jmp     @@skip_hack
@@hack:
                push    offset tf_mode
                
@@skip_hack:                
           
                push    ComHandle
                call    WriteFile
                cmp     eax, 0
                jnz     @@write_ok
                push    ComHandle
                call    CloseHandle
                mov     eax, -1
                jmp     @@exit
@@write_ok:
                push    ComHandle
                call    CloseHandle
                mov     eax, 0
@@exit:
                leave
                retn
Switch_mode     endp

FindUSBClass    proc near
                push    ebp
                mov     ebp, esp
                pusha

                push    12h             ; flags
                push    0               ; parent_hwnd
                push    0               ; enum
                push    offset DevClass ; class GUID
                call    SetupDiGetClassDevsA
                cmp     eax, -1
                jz      @@getclass_fail
                mov     ClassInfoSet, eax

                mov     DevIF_Index, 0

@@loop:
                mov     DevFound, 0
                push    offset DevIF_Data   ; DevIFData
                push    DevIF_Index         ; dev index
                push    offset DevClass     ; IF class GUID
                push    0                   ; dev info data
                push    ClassInfoSet
                mov     DevIF_Data, 1Ch     ; size
                call    SetupDiEnumDeviceInterfaces
                test    eax, eax
                jz      @@exit ; @@dev_enum_failed ; +

                push    0                    ; DevInfoData
                push    offset DevIF_ReqSize ; ReqSize
                push    0                    ; DevIFDetailSize
                push    0                    ; DevIFDetail
                push    offset DevIF_Data    ; DevIFData
                push    ClassInfoSet
                call    SetupDiGetDeviceInterfaceDetailA
                test    eax, eax
                jnz     @@dev_info_noerr

                call    GetLastError
                cmp     eax, 7Ah        ; err_insuff_buffer
                jnz     @@exit ; _Destroy_list

@@dev_info_noerr:
                push    DevIF_ReqSize ; 5Ah?
                push    40h
                call    GlobalAlloc
                mov     esi, eax
                test    esi, esi
                jz      @@exit ; _Destroy_list

                mov     dword ptr [esi], 5
                push    0               ; DevInfoData
                push    0               ; DevIF_Req_Size
                push    DevIF_ReqSize   ; DevIFDetailSize
                push    esi             ; DevIFDetail - dd size and str - path
                push    offset DevIF_Data ; DevIFData
                push    ClassInfoSet    ; devinfoset
                call    SetupDiGetDeviceInterfaceDetailA
                test    eax, eax
;                jz      @@Dev_GetDetail_failed
                jz      @@fail_gonext

                xor     eax,eax
                mov     al,[esi+22h] ; get IFindex
                and     al,0fh
                mov     IFindex,ax   ; store IFindex


                push    0
                push    0
                push    3
                push    0
                lea     edi, [esi+4]    ; DevIF path
                push    3
                push    0C0000000h
                push    edi
                call    CreateFileA
                mov     ebx, eax
                cmp     ebx, 0FFFFFFFFh
                jz      short @@fail_gonext

                push    offset str_buf
                push    0102h
                push    ebx
                call    USB_GetIFInfo

                push    esi
                push    edi
                mov     esi, offset str_motorola_tci
                mov     edi, offset str_buf

@@cmp_loop:
                lodsb
                cmp     al, 0
                jz      @@done
                mov     ah, [edi]
                inc     edi
                cmp     al, ah
                jz      @@cmp_loop
@@done:
                pop     edi
                pop     esi

                cmp     al, 0
                jnz     @@not_phone
                mov     DevFound, 1
                mov     Dev_Name_Ptr, esi
                mov     TCI_IF, ebx
                jmp     @@exit
@@not_phone:
                push    ebx
                call    CloseHandle
                inc     DevIF_Index
                jmp     @@loop

@@fail_gonext:
                push    esi
                call    GlobalFree
                inc     DevIF_Index
                jmp     @@loop

;@@dev_enum_failed:
;                call    GetLastError
;                jmp     @@exit_Destroy_list

;@@Dev_GetDetail_failed:

@@exit:
                push    ClassInfoSet
                call    SetupDiDestroyDeviceInfoList
@@getclass_fail:
                popa
                leave
                retn
FindUSBClass    endp


SwitchFromDataCard proc near
           push 12h
           push 0
           push 0
           push offset guidMassStorage
           call SetupDiGetClassDevsA
           cmp  eax,-1
           jz @@failed1
           mov  hDeviceInfo, eax
           
           mov  dwMSDevCount,0
           
@@loop1:
           push offset DeviceInterfaceData
           push dwMSDevCount
           push offset guidMassStorage
           push 0
           push hDeviceInfo
           call SetupDiEnumDeviceInterfaces
           inc  dwMSDevCount
           cmp  eax,0
           jz   @@loop_done

           push 0
           push offset DeviceInterfaceDetailDataSize
           push 0
           push 0
           push offset DeviceInterfaceData
           push hDeviceInfo
           call SetupDiGetDeviceInterfaceDetailA

           push DeviceInterfaceDetailDataSize
           push 0
           call GlobalAlloc
           mov  pDeviceInterfaceDetailData, eax
           mov  esi, pDeviceInterfaceDetailData
           mov  dword ptr [esi], 5h

           push 0
           push 0
           push DeviceInterfaceDetailDataSize
           push pDeviceInterfaceDetailData
           push offset DeviceInterfaceData
           push hDeviceInfo
           call SetupDiGetDeviceInterfaceDetailA

           mov  eax, pDeviceInterfaceDetailData
           add  eax, 4
           mov  lpMSDevicePath, eax

           push offset lpDevMoto
           push lpMSDevicePath
           call StrStrIA
           cmp  eax,0
           jz   @@not_moto

           push 0
           push 20000000h
           push 00000003h
           push 0
           push 00000003h
           push 0C0000000h
           push lpMSDevicePath
           call CreateFileA
           mov  hMSDevice,eax

           push 0
           push offset nBytesReturned
           push 2Ch
           push offset SwitchModePacket
           push 2Ch
           push offset SwitchModePacket
           push 0004D014h
           push hMSDevice
           call DeviceIoControl

           push hMSDevice
           call CloseHandle 


@@not_moto:
           push pDeviceInterfaceDetailData
           call GlobalFree
           jmp  @@loop1           
           
@@loop_done:           
           
@@failed1:           
                   retn
SwitchFromDataCard endp

CODE            ends

DATA            segment para public 'DATA' use32

guidMassStorage                 db 07h, 63h, 0f5h, 53h, 0bfh, 0b6h, 0d0h, 11h, 94h, 0f2h, 00h, 0a0h, 0c9h, 1eh, 0fbh, 8bh
SwitchModePacket                db 2ch, 00, 00, 00, 00, 00, 0ch, 00, 01, 00, 00, 00, 00, 00, 00, 00, 19h, 00, 00, 00, 00, 00, 00, 00
                                db 00, 00, 00, 00, 0d6h, 00, 00, 00, 00, 00, 00, 00, 00, 00, 08, 00, 00, 00, 00, 00
dwMSDevCount                    dd 00
DeviceInterfaceData             dd 28
                                dd 0h,0h,0h,0h
                                dd 00h
                                dd 00h
pDeviceInterfaceDetailData      dd 00h
DeviceInterfaceDetailDataSize   dd 00h
lpDevMoto                       db 'motorola', 00h
lpMSDevicePath                  dd 00h 
hMSDevice                       dd 00h
nBytesReturned                  dd 00h 
hDeviceInfo                     dd 00h


ManualCOM        dd 0

dwRasCb       dd 152
dwRasSize     dd 152
dwRasDevices  dd 0
lpRasDevInfo  dd 0
sRasModem     db 'modem', 00h
sRasMoto      db 'Motorola USB Modem', 00h
sRasMask      db '\\.\%s', 0 

FileRecCount dd 0

IFindex       dw 0000h
;MI            db '&MI_',00h


Our_Handle       dd 0
Mon_CB           dd 0
TCI_IF           dd -1
USB_Last_Err     dd 0
Thread_Handle    dd 0
Thread_Id        dd 0
Thread_Suspended dd 0
HackModeTF       dd 0

SwitchToAT_Buff  db  40h, 01h, 00h, 00h, 01h, 00h, 00h, 00h, 00h

Key_Class_handle dd 0
DevFound         dd 0
File_opened      dd 0
; PSTGetDeviceInterface data
Dev_Name_Ptr     dd 0

str_motorola_tci  db 'Motorola Test Command',0
;str_serialcom_key db 'HARDWARE\DEVICEMAP\SERIALCOMM',0
str_devclass_key  db 'SYSTEM\CurrentControlSet\Control\DeviceClasses\{4e1e1e15-52d7-11d4-852d-00105aa6f80b}\%s\#\Control',0
;str_usbser        db '\Device\USBSER000', 0
at_mode           db 'at+mode=8', 0Dh, 0Ah, 0
tf_mode           db 'at+mode=24', 0Dh, 0Ah, 0
;str_usb_modem     db '\\.\Motorola USB Modem' ,0,0,0,0,0,0,0,0


                align 4

; SetupUI data structures

ClassInfoSet    dd 0
DevIF_Index     dd 0

DevIF_Data      dd 0 ; size
DevIF_GUID      dd 0
DevIF_Flags     dd 0
DevIF_res       dd 0
                dd 0
                dd 0
                dd 0


DevIF_ReqSize   dd 0

DevClass        dd 4E1E1E15h, 11D452D7h, 10002D85h, 0BF8A65Ah

;msg_cmd_write_fail  db 'CMD: Data write fail!', 0Dh, 0Ah, 0
;msg_cmd_timeout     db 'CMD: Answer wait timeout!', 0Dh, 0Ah, 0
;msg_cmd_read_fail   db 'CMD: Data read fail!', 0Dh, 0Ah, 0
;msg_cmd_answer_fail db 'CMD: Answer packet invalid!', 0Dh, 0Ah, 0

;msg_usb_write_ok    db 'USB: Write data ok', 0Dh, 0Ah, 0
;msg_usb_read_ok     db 'USB: Read data ok', 0Dh, 0Ah, 0
;msg_usb_event_fail  db 'USB: Event create failed!', 0Dh, 0Ah, 0
;msg_usb_reset_fail  db 'USB: Event reset failed!', 0Dh, 0Ah, 0
;msg_usb_wait_fail   db 'USB: IO Time-out!', 0Dh, 0Ah, 0
;msg_usb_result_fail db 'USB: IO Failed!', 0Dh, 0Ah, 0
;msg_usb_size_fail   db 'USB: Answer size invlid!', 0Dh, 0Ah, 0

DevIO_Overlapped  dd 0
                  dd 0
                  dd 0
                  dd 0
DevIO_Event       dd 0
DevIO_Result      db 1010h dup (?) ; 1008h
;-----------------------------

CommTimeouts       dd ?
CommTimeouts_Multi dd ?
CommTimeouts_Const dd ?
CommTimeouts_W_Multi dd ?
CommTimeouts_W_Const dd ?

ComHandle       dd ?
at_readed       dd ?
Key_handle      dd ?
keyval_type     dd ?
keyval_size     dd ?
keyval_buf      db 100h dup (?)


Cmd_Send_Size    dd ?
Cmd_Recv_Size    dd ?
Cmd_Send_Buf     db 1000h dup (?)
Cmd_Recv_Buf     db 1000h dup (?)

Packet_ID        dw ?
                 dw ?
packet_size      dd ?
packet_buf       db 1000h dup (?)
status_read_size dd ?
status_read_buf  db 0Ch dup (?) ; 0Ch bytes
data_read_size   dd ?
data_read_buf    dd 1000h dup (?)
ReadStatus_Ticks dd ?

IF_Info_cmd      dd ?
IF_Info_recvd    dd ?

str_buf         db 1000h dup (?)

seem_num        dw ?
seem_rec        dw ?
seem_ofs        dw ?
seem_bytes      dw ?
seem_data       db 2710h dup (?)
seem_buf        db 2710h dup (?)

stelem_result   dd ?
seem_read_bytes dd ?

FileList_RecSize dd ?
Search_Buf       db 1000h dup (?)


DATA            ends

include externs.inc

                end start
